<?php

/**
 * Backend of Memberpages_XH
 *
 * @package	Memberpages
 * @copyright	Copyright (c) 2012-2014 svasti (Frank Ziesing) <http://frankziesing.de/cmsimple/>
 * @license	http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 * @version     3.4.1
 * @link	http://frankziesing.de/cmsimple/?Start:Memberpages
 */


/**
 * Prevent direct access
 */
if ((!function_exists('sv')) || preg_match('!admin.php!i', sv('PHP_SELF')))die('Access denied');


/**
 * Returns the members list as array
 */
function memberpagesMemberarray()
{
    global $pth,$plugin_cf;

    // get the members data
    // from a csv file
    if($plugin_cf['memberpages']['usecsvfile'])
    {
        $user = $password = $access_level = $email = $fullname = $expires = array();

        $csv_array = file($pth['folder']['base'] . $plugin_cf['memberpages']['csvfile']);


        foreach($csv_array as $key => $value) {
             $data = explode(',', $csv_array[$key]);
             array_push($user,         trim($data[0]));
             array_push($password,     trim($data[1]));
             array_push($access_level, trim($data[2]));
             if(!isset($data[3]))      $data[3] = '';
             array_push($email,        trim($data[3]));
             if(!isset($data[4]))      $data[4] = '';
             array_push($fullname,     trim($data[4]));
             if(!isset($data[5]))      $data[5] = '';
             array_push($expires,      trim($data[5]));
        }
    }
    // or from a php file
    else
    {
        include($pth['folder']['base'] . $plugin_cf['memberpages']['phpfile']);

        $user         = explode(",", $members['user_array']);
        $password     = explode(",", $members['pass_array']);
        $access_level = explode(",", $members['accesslevel_array']);
        $email        = explode(",", $members['email_array']);
        $fullname     = explode(",", $members['fullname_array']);
        $expires      = explode(",", $members['expires_array']);

        foreach ($user as $key=>$value) {
            if(!isset($password[$key])) $password[$key] = '';
            if(!isset($access_level[$key])) $access_level[$key] = '';
            if(!isset($email[$key])) $email[$key] = '';
            if(!isset($fullname[$key])) $fullname[$key] = '';
            if(!isset($expires[$key])) $expires[$key] = '';
        }
    }

    $memberarray = array('user'     =>  $user,
                         'pass'     =>  $password,
                         'access'   =>  $access_level,
                         'email'    =>  $email,
                         'fullname' =>  $fullname,
                         'expires'  =>  $expires);

    return $memberarray;
}


/**
 * Returns the editable log file
 * 
 * @return string  The (X)HTML.
 */
function memberpagesLog()
{
    global $pth,$plugin,$plugin_tx,$plugin_cf;
    $o = '';

    if(isset($_POST['save_log']))  {
        file_put_contents($pth['folder']['plugins'].$plugin."/logfile/logfile.txt",$_POST['logfile']);
    }

    //======== logfile with save button ==============
    $logfile=file_get_contents($pth['folder']['plugins'].$plugin."/logfile/logfile.txt");

    $o .= '<p class="mpp_pluginname">Memberpages_XH ' . $plugin_cf['memberpages']['version'] . '</p>';
    $o .= '<form method="POST" action="">' . "\n"
       .  tag('input type="hidden" name="save_log" value=true') . tag('br') . "\n"
       .  tag('input type="submit" value=" &nbsp; ' . $plugin_tx['memberpages']['save_log'].' &nbsp; "') . tag('br') . "\n"
       .  '<textarea  class="mpp_log" name="logfile" id="logfile">'
       .  $logfile
       .  '</textarea>'
       .  '</form>' . "\n";

   $o .=  '<script type="text/javascript">
                        // <![CDATA[
            document.getElementById("logfile").scrollTop = 999999;
                       // ]]>
                        </script>';
    return $o;
}



/**
 *	Reads the changes to the members list and saves them,
 *	returns either an errormessage or goes back to members list
 */
function memberpagesSaveList()
{
    global $plugin_cf,$plugin_tx,$memberslist,$csvmemberslist;
    $o = '';

    $memberarray = memberpagesMemberarray();


    $delete   = isset($_POST['delete'])   ? $_POST['delete']   : array();
    $add      = isset($_POST['add_x'])    ? $_POST['add_x']    : false;
    $user     = isset($_POST['user'])     ? $_POST['user']     : array();
    $pass     = isset($_POST['pass'])     ? $_POST['pass']     : array();
    $email    = isset($_POST['email'])    ? $_POST['email']    : array();
    $fullname = isset($_POST['fullname']) ? $_POST['fullname'] : array();
    $expires  = isset($_POST['expires'])  ? $_POST['expires']  : array();
    $sort     = isset($_POST['sort'])     ? $_POST['sort']     : false;

    // $notice=print_r($user,true);

    if($plugin_cf['memberpages']['accessmode'] > 2) {
        $check1 = isset($_POST['check1']) ? $_POST['check1'] : array();
        $check2 = isset($_POST['check2']) ? $_POST['check2'] : array();
        $check3 = isset($_POST['check3']) ? $_POST['check3'] : array();
        $check4 = isset($_POST['check4']) ? $_POST['check4'] : array();
        $check5 = isset($_POST['check5']) ? $_POST['check5'] : array();

        foreach ($user as $i=>$value) {
            $check1[$i] = isset($check1[$i])? $check1[$i] : '0';
            $check2[$i] = isset($check2[$i])? $check2[$i] : '0';
            $check3[$i] = isset($check3[$i])? $check3[$i] : '0';
            $check4[$i] = isset($check4[$i])? $check4[$i] : '0';
            $check5[$i] = isset($check5[$i])? $check5[$i] : '0';
            $access[$i] = bindec($check5[$i] . $check4[$i] . $check3[$i] . $check2[$i] . $check1[$i]);
        }
    } else {
        $access = isset($_POST['access']) ? $_POST['access'] : array();
    }

    // change sent values
    foreach ($user as $key=>$value) {
        array_splice($memberarray['user'],$key,1,stsl(str_replace(array(',',' ','"','\\'),'',$user[$key])));
        array_splice($memberarray['access'],$key,1,$access[$key]);
        array_splice($memberarray['pass'],$key,1,stsl(str_replace(array(',',' ','"','\\'),'',$pass[$key])));
        array_splice($memberarray['email'],$key,1,stsl(str_replace(array(',',' ',"'",'"','\\'),'',$email[$key])));
        array_splice($memberarray['fullname'],$key,1,stsl(str_replace(array(',','"'),'',$fullname[$key])));

        if (!preg_match('/\d{4}\-\d{2}-\d{2}/',$expires[$key])) $expires[$key] = "";
        array_splice($memberarray['expires'],$key,1,$expires[$key]);
    }

    if($add) {
        $newpassword = $plugin_cf['memberpages']['default_password'];
        if($plugin_cf['memberpages']['generate_password']==2) {
            $newpassword = substr(str_shuffle("1234567890abcdefghijklmnopqrstuvwxyz!?&+@"),1,5);
        }
        if($plugin_cf['memberpages']['generate_password']) {
            $tmp = preg_split("//u", $newpassword, -1, PREG_SPLIT_NO_EMPTY);
            shuffle($tmp);
            $newpassword = join("", $tmp);
            $newpassword = preg_replace('/[a-z|äöü]/ie', '(rand(0,1) ? \'$0\' ^ str_pad(\'\', strlen(\'$0\'), \' \') : \'$0\')', $newpassword);
        }
        array_splice($memberarray['user'],0,0,'');
        array_splice($memberarray['access'],0,0,0);
        array_splice($memberarray['pass'],0,0,$newpassword);
        array_splice($memberarray['email'],0,0,'');
        array_splice($memberarray['fullname'],0,0,'');
        array_splice($memberarray['expires'],0,0,'');
    }

    if($delete) {
        foreach ($delete as $key=>$value) {
            array_splice($memberarray['user'],$key,1);
            array_splice($memberarray['access'],$key,1);
            array_splice($memberarray['pass'],$key,1);
            array_splice($memberarray['email'],$key,1);
            array_splice($memberarray['fullname'],$key,1);
            array_splice($memberarray['expires'],$key,1);
        }
    }

    if($sort) array_multisort($memberarray['user'],
                              $memberarray['pass'],
                              $memberarray['access'],
                              $memberarray['email'],
                              $memberarray['fullname'],
                              $memberarray['expires']);
    // check double user entries
    $checkusers = array_count_values($memberarray['user']);
//    $notice = '';
    foreach ($checkusers as $key=>$value) {
    	if($value >1 && $key) {
            if($notice) $notice .= ', ';
            $notice .= $key;
        }
    }
    if($notice) {
        $o .= '<div class="mpp_message" style="line-height:2.4;">'
           .  sprintf($plugin_tx['memberpages']['error_username_not_unique'], $notice)
           .  '</div>';
    }

    // save
    if($plugin_cf['memberpages']['usecsvfile'])
    {
        foreach ($memberarray['user'] as $key => $value)
        {
            $newcsvarray[$key] = trim($memberarray['user'][$key].','
                              . $memberarray['pass'][$key].','
                              . $memberarray['access'][$key].','
                              . $memberarray['email'][$key].','
                              . $memberarray['fullname'][$key].','
                              . $memberarray['expires'][$key]);
        }

        $newcsvfile = implode("\n",$newcsvarray);

        file_put_contents($csvmemberslist,$newcsvfile);
    }
    else
    {
        $text  = '<?php'
              .  "\n"
              .  'if ((!function_exists("sv")) || preg_match("!admin.php!i", sv("PHP_SELF")))die("Access denied");'
              .  "\n"
              .  '$members[\'user_array\']="'. implode(',', $memberarray['user']) . '";'
              .  "\n"
              .  '$members[\'pass_array\']="'. implode(',', $memberarray['pass']) . '";'
              .  "\n"
              .  '$members[\'accesslevel_array\']="'. implode(',', $memberarray['access']) . '";'
              .  "\n"
              .  '$members[\'email_array\']="'. implode(',', $memberarray['email']) . '";'
              .  "\n"
              .  '$members[\'fullname_array\']="'. implode(',', $memberarray['fullname']) . '";'
              .  "\n"
              .  '$members[\'expires_array\']="'. implode(',', $memberarray['expires']) . '";'
              .  "\n"
              .  '?>';

        file_put_contents($memberslist,$text);
    }

    if(!$notice) {
        header('Location: '.CMSIMPLE_URL.'?&memberpages&admin=plugin_main');
        exit;
    }

    return $o;
}




initvar('memberpages');

if($memberpages)
{
    $plugin = basename(dirname(__FILE__),"/");
    $admin  = isset($_POST['admin']) ? $_POST['admin'] : $admin = isset($_GET['admin']) ? $_GET['admin'] : '';
    $action = isset($_POST['action']) ? $_POST['action'] : $action = isset($_GET['action']) ? $_GET['action'] : '';

    $memberpageimages=$pth['folder']['plugins'].$plugin."/images/";


    $plugin_main_on   = ( !$admin || $admin=='plugin_main') ?        ' class="mpp_selected"':'';
    $config_on        = ($admin=='plugin_config' && $action=='plugin_edit')? ' class="mpp_selected"':'';
    $file_on          = ($admin=='plugin_config' && $action=='filestorage')? ' class="mpp_selected"':'';
    $stylesheet_on    = $admin=='plugin_stylesheet'?                 ' class="mpp_selected"':'';
    $language_on      = $admin=='plugin_language'?                   ' class="mpp_selected"':'';
    $credits_on       = $action=='credits'?                          ' class="mpp_selected"':'';
    $log_on           = $action=='log'?                              ' class="mpp_selected"':'';

    $o .= '<p class="mpp_admin_menu">' . "\n"
       .  '<a'.$plugin_main_on  .' href="?&amp;' . $plugin . '&amp;admin=plugin_main&action=plugin_text" />' .$plugin_tx[$plugin]['menu_main'].'</a>&nbsp; ' . "\n"
       .  '<a'.$log_on          .' href="?&amp;' . $plugin . '&amp;admin=plugin_config&action=log" />' .$plugin_tx[$plugin]['menu_log'].'</a>&nbsp; ' . "\n"
       .  '<a'.$config_on       .' href="?&amp;' . $plugin . '&amp;admin=plugin_config&action=plugin_edit" />' .$plugin_tx[$plugin]['menu_config'].'</a>&nbsp; ' . "\n"
       .  '<a'.$file_on         .' href="?&amp;' . $plugin . '&amp;admin=plugin_config&action=filestorage" />' .$plugin_tx[$plugin]['menu_file'].'</a>&nbsp; ' . "\n"
       .  '<a'.$stylesheet_on   .' href="?&amp;' . $plugin . '&amp;admin=plugin_stylesheet&action=plugin_text" />' .$plugin_tx[$plugin]['menu_css'].'</a>&nbsp; ' . "\n"
       .  '<a'.$language_on     .' href="?&amp;' . $plugin . '&amp;admin=plugin_language&action=plugin_edit" />' .$plugin_tx[$plugin]['menu_language'].'</a>&nbsp; ' . "\n"
       .  '<a                      href="'.        $pth['file']['plugin_help'] . '" target="_blank" />' .$plugin_tx[$plugin]['menu_help'].'</a>&nbsp; ' . "\n"
       .  '<a'.$credits_on      .' href="?&amp;' . $plugin . '&amp;admin=plugin_config&action=credits" />' .$plugin_tx[$plugin]['menu_credits'].'</a></p>' . "\n";

    if($admin == '' && $action != 'credits') $admin = 'plugin_main';

    if($admin != 'plugin_main' and $admin != 'plugin_config')
    {
        $o .= plugin_admin_common($action,$admin,$plugin);
    }

    if($action=='credits') {
        $o.= '<h2>Memberpages_XH ' . $plugin_cf['memberpages']['version'] . '</h2>' . "\n"
           . '<p>&copy; 2013 by <a href="http://frankziesing.de/cmsimple/">svasti</a></p>'."\n"
           . '<p>based on:</p>' ."\n" . '<ul>'
           . '<li>versions 3.0 and higher by <a href="http://frankziesing.de/cmsimple/">svasti</a></li>'."\n"
           . '<li>versions 2.0–2.3 XH by <a href="http://www.ge-webdesign.de">ge-webdesign.de</a></li>'."\n"
           . '<li>versions 0.1–1.7 by <a href="http://cmsimpleplugins.svarrer.dk">cmsimpleplugins.svarrer.dk</a></li>'."\n".'</ul>' . "\n"
           . '<p>This program is free software: you can redistribute it and/or modify '
	       . 'it under the terms of the GNU General Public License as published by '
	       . 'the Free Software Foundation, either version 3 of the License, or '
	       . '(at your option) any later version.</p>'
           . '<p>For a copy of the GNU General Public License see '
           . '<a href="' . $sn . '?' . uenc($cf['menu']['legal']) . '">'
           . $cf['menu']['legal']
           . '</a></p>' ."\n"
           . '<p><small><b>Acknowledgement:</b></small><br />'
           . 'Memberpages_XH uses Memberlist_XH by <a href="http://3-magi.net">cmb</a> to show which members are logged in.<p>'
           . "\n";

    }

// preliminary action on calling the plugin from CMSimple's plugins menu
//===========================================================

    if(isset($plugin_cf['memberpages']['version'])) {

        //check permissions which are not checked by pluginloader
        if(!is_writable($pth['folder']['plugins'].$plugin."/config/config.php"))
            e('cntwriteto', 'file',   $pth['folder']['plugins'].$plugin.'/config/config.php');

        $handle = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', "a+");
        fclose($handle);
        if(!is_writable($pth['folder']['plugins'].$plugin."/logfile/logfile.txt"))
            e('cntwriteto', 'file',   $pth['folder']['plugins'].$plugin.'/logfile/logfile.txt');

        if($plugin_cf['memberpages']['usecsvfile']) {
            $csvmemberslist = $pth['folder']['base'].$plugin_cf['memberpages']['csvfile'];
            $csv_folder = substr($csvmemberslist,0, strrpos($csvmemberslist, '/'));
            if(!is_writable($csv_folder))
                e('cntwriteto', 'folder',   $csv_folder);
            if(is_file($csvmemberslist) && !is_writable($csvmemberslist))
                e('cntwriteto', 'file',   $csvmemberslist);
            if(is_file($csvmemberslist.'.bak') && !is_writable($csvmemberslist.'.bak'))
                e('cntwriteto', 'file',   $csvmemberslist.'.bak');

        } else {
            $phpmemberslist = $pth['folder']['base'].$plugin_cf['memberpages']['phpfile'];
            $php_folder = substr($phpmemberslist,0, strrpos($phpmemberslist, '/'));
            if(!is_writable($php_folder))
                e('cntwriteto', 'folder',   $php_folder);
            if(!is_writable($phpmemberslist))
                e('cntwriteto', 'file',   $plugin_cf['memberpages']['phpfile']);
        }
    }

##################################################################################################


// action on choosing "members list" (Plugin main) in plugin menu
//================================================================
    if($admin == 'plugin_main' && $action != 'memberslist')
    {
        // ****************************************
        // activation form
        // ****************************************
        if(!$plugin_cf['memberpages']['version'] || version_compare($plugin_cf['memberpages']['version'], '3.4.1', '!=')) {

            $o .=  '<h1 style="border:2px red solid;background:yellow;text-align:center;">'
                .  $plugin_tx['memberpages']['activation_alert']
                .  tag('br')
                . '<form action="" method="POST">'
                .  tag('input type="hidden" name="activate_memberpages" value="1"')
                .  tag('input type="submit" style="font-weight:bold;padding:0 1em;letter-spacing:.05em;" value="'
                .  $plugin_tx['memberpages']['activation_click_here']
                .  '"')
                . '<form> '
                . $plugin_tx['memberpages']['activation_call']
                . '</h1>';

        } else {

            $memberarray   = memberpagesMemberarray();
            $user          = $memberarray['user'];
            $password      = $memberarray['pass'];
            $access_level  = $memberarray['access'];
            $email         = $memberarray['email'];
            $fullname      = $memberarray['fullname'];
            $expires       = $memberarray['expires'];


            // only changed data should be transmitted to prevent transmitting the whole file and risking data loss in large member files
            $hjs .= '<script type="text/javascript">'."\n"
        	    .'/* <![CDATA[ */'."\n"
        	    .'function makeName(j) {
                      document.getElementById("line"+j).className = "mpp_changes";
                      var pass = "pass["+j+"]";
                      document.getElementById("pass"+j).name = pass;
                      var user = "user["+j+"]";
                      document.getElementById("user"+j).name = user;
                      var email = "email["+j+"]";
                      document.getElementById("email"+j).name = email;
                      var fullname = "fullname["+j+"]";
                      document.getElementById("fullname"+j).name = fullname;
                      var expires = "expires["+j+"]";
                      document.getElementById("expires"+j).name = expires;';

            if($plugin_cf['memberpages']['accessmode'] > 2) {
                $hjs .= "\n"
                     .'
                      var check1 = "check1["+j+"]";
                      document.getElementById("check1a"+j).name = check1;

                      var check2 = "check2["+j+"]";
                      document.getElementById("check2a"+j).name = check2;

                      var check3 = "check3["+j+"]";
                      document.getElementById("check3a"+j).name = check3;

                      var check4 = "check4["+j+"]";
                      document.getElementById("check4a"+j).name = check4;

                      var check5 = "check5["+j+"]";
                      document.getElementById("check5a"+j).name = check5;';
            } else {
                $hjs .= 'var access = "access["+j+"]";
                      document.getElementById("access"+j).name = access;';
            }
            $hjs .= '}'."\n"
        	     .  '/* ]]> */'."\n"
        	     .  '</script>'."\n";

  
            // headline + version nr
            $o .= '<p class="mpp_pluginname">Memberpages_XH ' . $plugin_cf['memberpages']['version'] . '</p>'
                . '<h1>' . count($user) . ' ' . $plugin_tx['memberpages']['menu_main'] . '</h1>' . "\n";

            // start table + input form
            $o .= '<form method="POST" action="'.$sn.'?&memberpages">'."\n";
            $o .= '<table class="mpp_configtable" cellpadding="1" cellspacing="3">' . "\n";


            // table headline
            $o .= '<tr><th>'
               .  $plugin_tx['memberpages']['memberslist_username']
               .  '</th><th>'
               .  $plugin_tx['memberpages']['memberslist_password']
               .  '</th>' . "\n";
            if($plugin_cf['memberpages']['accessmode']) {
                $o .= '<th>' . $plugin_tx['memberpages']['memberslist_accesslevel'];
                if($plugin_cf['memberpages']['accessmode'] > 2) $o .= ' 1-'.$plugin_cf['memberpages']['accessmode'];
                $o .= '</th>' . "\n";
            }

            if($plugin_cf['memberpages']['register_email'] || $plugin_cf['memberpages']['show_expires']) {
                $o .= '<th style="width:40%; text-align:center;">';
                if($plugin_cf['memberpages']['register_email']) $o .= $plugin_tx['memberpages']['memberslist_email'];
                $o .= '</th>' . "\n";
            } 

            $o .= '<td>'
               .  tag('input type="image" src="'.$memberpageimages
               .  '/add.png" style="width:16;height:16" name="add" value="add" alt="Add entry"')
               .  "</td></tr>\n";

            // rows with member data document.getElementById(\"line'.$j.'\").style.display = \"none\"
            foreach($user as $j=>$i)
            {
                // start a new row for every member
                $o .= '<tr id="line'.$j.'"
                      OnKeyDown="'
                      .'makeName('.$j.');'
                      .'document.getElementById(\'check1a'.$j.'\').style.background = \'#efe\';'
                      .'">'."\n"
                   .  '<td colspan="2"><span style="white-space:nowrap;">'
                    //name
                   .  tag('input type="text" style="width:48%;margin:0 1% 0 0;" value="'.$i.'" id="user'.$j.'"')
                    //password
                   .  tag('input type="text" style="width:48%;margin:0;" value="'.$password[$j].'" id="pass'.$j.'"')
                   .  '</span>';

                if($plugin_cf['memberpages']['show_fullname']) {
                    $o .=  tag('input type="text" style="width: 98%;" value="'.$fullname[$j].'" id="fullname'.$j.'"  placeholder="'
                       .   $plugin_tx['memberpages']['memberslist_fullname'] . '"');
                } else {
                    $o .=  tag('input type="hidden" value="'.$fullname[$j].'" id="fullname'.$j.'"');
                }
                $o .= '</td>' . "\n";

                // if accessmode is wanted start accessmode field
                if($plugin_cf['memberpages']['accessmode']) {
                    $o .= '<td style="text-align:center;" OnClick="makeName('.$j.')">';

                    // bitmask matching, access level numbers are converted into binary checkbox contents
                    if($plugin_cf['memberpages']['accessmode'] > 2) {

                        $o .= '<span style="white-space:nowrap;">';

                        for ($k = 1; $k <= $plugin_cf['memberpages']['accessmode']; $k++) {
                            $checked = ($access_level[$j] & pow(2,($k-1))) ? ' checked=checked' : '';
                           $o .= tag('input type="checkbox" '.$checked.' value="1" id="check'.$k.'a'.$j.'"  ');
                        }
                        for (; $k <= 5; $k++) {
                            $value = ($access_level[$j] & pow(2,($k-1))) ?  1 : 0;
                            $o .= tag('input type="hidden" value='.$value.' id="check'.$k.'a'.$j.'"  ');
                        }
                        $o .=  '</span></td>' . "\n";

                    } else {
                        $x = 0;
                        $values_select = '';
                        for($k = 0; $k <= $plugin_cf['memberpages']['selectable_levels']; $k++) {
                            $selected = '';
                            if($k == $access_level[$j]) {$selected = ' selected'; $x++;}
                            $values_select .= "<option value='$k'$selected> &nbsp; &nbsp; $k &nbsp; &nbsp; </option>\n" ;
                        }
                        $o .= '<select id="access'.$j.'">';
                        if($x==0 && $access_level[$j]) {
                            $o .= "<option value='$access_level[$j]' selected='selected'> &nbsp; &nbsp;  $access_level[$j] &nbsp; </option>\n" ;
                        }
                        $o .= "$values_select</select>\n</td>\n";
                    }
                } else {
                    // if accessmode is not wanted save at least possible values for later reuse
                    $o .= tag('input type="hidden" value='.$access_level[$j].' id="access'.$j.'"');
                }

                if($plugin_cf['memberpages']['register_email'] || $plugin_cf['memberpages']['show_expires']) {
                    $o .= '<td>';
                    if($plugin_cf['memberpages']['register_email']) {
                        $o .= tag('input type="text" style="width: 96%;" value="'.$email[$j].'" id="email'.$j.'"');
                    }
                    if($plugin_cf['memberpages']['show_expires']) {
                        $o .= '<span style="float:right;">'
                           .  $plugin_tx['memberpages']['memberslist_expires']
                           .  ' '
                           .  tag('input type="text" style="width: 50%;text-align:center;" value="'.$expires[$j].'" id="expires'.$j.'" placeholder="'
                           .  $plugin_tx['memberpages']['memberslist_date_format'] . '"')
                           .  '</span>';
                    } else {
                        $o .=  tag('input type="hidden" value="'.$expires[$j].'" id="expires'.$j.'"');
                    }
                    $o .= '</td>' . "\n";
                }

                // delete button
                $o .= '<td>' . tag("input type='image' src='" . $memberpageimages
                   .  "/delete.png' style='width:16;height:16' name='delete[$j]' value='delete' alt='Delete entry'");

                $o .=  "</td></tr>\n";

            }

            $o .= '</table>' . "\n"
               .  tag('input type="hidden" value="memberslist" name="action"')
               .  tag('input type="submit" value=" &nbsp; '.$plugin_tx['memberpages']['memberslist_save'].' &nbsp; " name="send"')
               .  tag('input type="submit" value=" &nbsp; '.$plugin_tx['memberpages']['memberslist_sort'].' &nbsp; " name="sort"')
               .  '</form>' . "\n";

        }
    }




###################################################################################################


// action on choosing "log" in plugin menu
//================================================
    if($admin == 'plugin_config'  && $action == 'log') $o .= memberpagesLog();


###################################################################################################


// action on choosing "config" in plugin menu
//================================================
    if($admin == 'plugin_config' && $action == 'plugin_edit')
    {

        if(isset($_GET['error'])) {
            $o .= '<p class="cmsimplecore_warning">'.$plugin_tx['memberpages']['error_texttrigger'].'</p>';
        }
        if($plugin_cf['memberpages']['passwordforgotten'] && !$plugin_cf['memberpages']['site_email']) {
            $o .= '<p class="cmsimplecore_warning">'.$plugin_tx['memberpages']['error_site_email'].'</p>';
        }

        // headline log/config
        $o .= '<p class="mpp_pluginname">Memberpages_XH ' . $plugin_cf['memberpages']['version'] . '</p>';
        $o .= '<h1>'.$plugin_tx['memberpages']['menu_config_headline'].'</h1>' . "\n";


        //config settings form
        $o .= '<form action="'.$sn.'?&memberpages&admin=plugin_config&action=plugin_edit" method="POST">';

        // prepare checkboxes
        $pdtabchecked             = $plugin_cf['memberpages']['pdtab']       ?       'checked="checked"' : '';
        $texttriggerchecked       = $plugin_cf['memberpages']['texttrigger'] ?       'checked="checked"' : '';
        $remembermechecked        = $plugin_cf['memberpages']['rememberme']  ?       'checked="checked"' : '';
        $smallloginchecked        = $plugin_cf['memberpages']['small_login'] ?       'checked="checked"' : '';
        $pwforgottenchecked       = $plugin_cf['memberpages']['passwordforgotten'] ? 'checked="checked"' : '';
        $members_emailchecked     = $plugin_cf['memberpages']['register_email']?     'checked="checked"' : '';
        $show_activeschecked      = $plugin_cf['memberpages']['show_actives']?       'checked="checked"' : '';
        $show_fullnamechecked     = $plugin_cf['memberpages']['show_fullname']?      'checked="checked"' : '';
        $show_expireschecked      = $plugin_cf['memberpages']['show_expires']?       'checked="checked"' : '';
        $controlpanelchecked      = $plugin_cf['memberpages']['controlpanel']?       'checked="checked"' : '';

        $o .= '<p>'
           .  tag('input type="hidden" name="pdtab" value="0"')
           .  tag('input type="checkbox" '.$pdtabchecked.' value="1" name="pdtab" OnClick="
                    if(this.checked) {
                        document.getElementById(\'pdtab_color_select\').style.display = \'table-row\';
                    } else {
                        document.getElementById(\'pdtab_color_select\').style.display = \'none\';
                    } ; "')
           .  ' '
           .  $plugin_tx['memberpages']['memberpages_via_pdtab']
           .  '</p>' . "\n"

           .  '<p>'
           .  tag('input type="hidden" name="texttrigger" value="0"')
           .  tag('input type="checkbox" '.$texttriggerchecked.' value="1" name="texttrigger"')
           .  ' '
           .  $plugin_tx['memberpages']['memberpages_via_texttrigger']
           .  '</p>' . "\n"

           .  '<p>'
           .  tag('input type="hidden" name="memberpages_smalllogin" value="0"')
           .  tag('input type="checkbox" '.$smallloginchecked.' value="1" name="memberpages_smalllogin"')
           .  ' '
           .  $plugin_tx['memberpages']['config_small_login']
           .  '</p>' . "\n"

           .  '<p>'
           .  tag('input type="hidden" name="memberpages_rememberme" value="0"')
           .  tag('input type="checkbox" '.$remembermechecked.' value="1" name="memberpages_rememberme"')
           .  ' '
           .  $plugin_tx['memberpages']['config_show_remember_me']
           .  '</p>' . "\n";

        if($plugin_cf['memberpages']['usecsvfile']) {
            $o .= '<p>'
               .  tag('input type="hidden" name="controlpanel" value="0"')
               .  tag('input type="checkbox" '.$controlpanelchecked.' value="1" name="controlpanel"')
               .  ' '
               .  $plugin_tx['memberpages']['config_show_controlpanel']
               .  '</p>' . "\n";
        }

        $o .= '<p>'
           .  tag('input type="hidden" name="members_email" value="0"')
           .  tag('input type="checkbox" '.$members_emailchecked.' value="1" name="members_email"')
           .  ' '
           .  $plugin_tx['memberpages']['config_register_members_email']
           .  '</p>' . "\n";

        if(phpversion() >=5) {
            $o .= '<p>'
               .  tag('input type="hidden" name="show_actives" value="0"')
               .  tag('input type="checkbox" '.$show_activeschecked.' value="1" name="show_actives" OnClick="
                        if(this.checked) {
                            document.getElementById(\'show_fullname\').style.display = \'block\';
                        } else {
                            document.getElementById(\'show_fullname\').style.display = \'none\';
                        } ; "')
               .  ' '
               .  $plugin_tx['memberpages']['config_show_actives']
               .  '</p>' . "\n";

            $show_fullname_display = ($plugin_cf['memberpages']['show_actives'])
                                   ? 'style="display:block;"':'style="display:none;"';
            $o .= '<p id="show_fullname" '.$show_fullname_display.'>'
               .  tag('input type="hidden" name="show_fullname" value="0"')
               .  tag('input type="checkbox" '.$show_fullnamechecked.' value="1" name="show_fullname"')
               .  ' '
               .  $plugin_tx['memberpages']['config_show_fullname']
               .  '</p>' . "\n";
        } else {
            $o .= tag('input type="hidden" name="show_actives" value="0"');
        }

        $o .= '<p>'
           .  tag('input type="hidden" name="show_expires" value="0"')
           .  tag('input type="checkbox" '.$show_expireschecked.' value="1" name="show_expires"')
           .  ' '
           .  $plugin_tx['memberpages']['config_show_expires']
           .  '</p>' . "\n";

        $o .= '<p>'
           .  tag('input type="hidden" name="passwordforgotten" value="0"')
           .  tag('input type="checkbox" '.$pwforgottenchecked.' value="1" name="passwordforgotten" OnClick="
                    if(this.checked) {
                        document.getElementById(\'site_email_address\').style.display = \'table-row\';
                        document.getElementById(\'admin_email_address\').style.display = \'table-row\';
                    } else {
                        document.getElementById(\'site_email_address\').style.display = \'none\';
                        document.getElementById(\'admin_email_address\').style.display = \'none\';
                    } ; "')
           .  ' '
           .  $plugin_tx['memberpages']['passwordforgotten_option']
           .  '</p>' . "\n";

        $o .= '<table class="mpp_config">' . "\n";

        // incase of forgotten password, we need a sender's email to send missing passwords
        $site_email_display = ($plugin_cf['memberpages']['passwordforgotten'])
                               ? 'style="display:table-row;"':'style="display:none;"';
        $o .= '<tr id="site_email_address" '. $site_email_display.'><td>'
           .  $plugin_tx['memberpages']['config_site_email']
           .  '</td><td>' . "\n"
           .  tag('input type="text" name="site_email" value="'
           .  $plugin_cf['memberpages']['site_email']
           .  '" placeholder="'
           .  $plugin_tx['memberpages']['config_site_email_text'] . '"')
           .  '</td></tr>' . "\n";

        // incase of forgotten password and no email, we need an admins's email to send notice
        $o .= '<tr id="admin_email_address" '. $site_email_display.'><td>'
           .  $plugin_tx['memberpages']['config_admin_email']
           .  '</td><td>' . "\n"
           .  tag('input type="text" name="admin_email" value="'
           .  $plugin_cf['memberpages']['admin_email']
           .  '" placeholder="'
           .  $plugin_tx['memberpages']['config_admin_email_text'] . '"')
           .  '</td></tr>' . "\n";


        // default password
        $o .= '<tr><td>&nbsp;</td><td>&nbsp;</td></tr><tr><td>'
           .  $plugin_tx['memberpages']['config_default_password'] . '</td><td style="white-space:nowrap;">'

           .  tag('input type="text" style="width:30%" name="memberpages_defaultpassword" value="'.$plugin_cf['memberpages']['default_password'].'"')

           .  '<select style="width:69%" name="generate_password">'
           .  '<option value="0">'.$plugin_tx['memberpages']['password_take_default']."</option>\n"
           .  '<option value="1"';
        if($plugin_cf['memberpages']['generate_password']=="1") $o .=' selected';
        $o .= '>'.$plugin_tx['memberpages']['password_take_default_variation']."</option>\n"
           .  '<option value="2"';
        if($plugin_cf['memberpages']['generate_password']=="2") $o .=' selected';
        $o .= '>'.$plugin_tx['memberpages']['password_generate_random_string']."</option>\n"
           .  "</select>\n"
           .  '</td></tr>' . "\n"

        // accessmode choice
        //====================
           .  '<tr><td>&nbsp;</td><td>&nbsp;</td></tr><tr><td>'
           .  $plugin_tx['memberpages']['access_mode']
           . '</td><td>';

        $o .= '<select name="accessmode" OnChange="
                    if(this.options[this.selectedIndex].value == \'1\' ||
                       this.options[this.selectedIndex].value == \'2\') {
                        document.getElementById(\'access_levels\').style.display = \'table-row\';
                    } else {
                        document.getElementById(\'access_levels\').style.display = \'none\';
                    } ; ">';

        // all members can access all memberpages
        $o .= '<option value="0">'.$plugin_tx['memberpages']['access_to_all_memberpages']."</option>\n"

        // equal+lower
           .  '<option value="1"';
        if($plugin_cf['memberpages']['accessmode']=="1") $o .=' selected';
        $o .= '>'.$plugin_tx['memberpages']['access_equal_or_higher']."</option>\n"

        // equal
           .  '<option value="2"';
        if($plugin_cf['memberpages']['accessmode']=="2") $o .=' selected';
        $o .= '>'.$plugin_tx['memberpages']['access_must_match_pageaccess']."</option>\n"

        // bitmask 3 bits
           .  '<option value="3"';
        if($plugin_cf['memberpages']['accessmode']=="3") $o .=' selected';
        $o .= '>'.sprintf($plugin_tx['memberpages']['access_must_match_bitmask'],3)."</option>\n"

        // bitmask 4 bits
           .  '<option value="4"';
        if($plugin_cf['memberpages']['accessmode']=="4") $o .=' selected';
        $o .= '>'.sprintf($plugin_tx['memberpages']['access_must_match_bitmask'],4)."</option>\n"

        // bitmask 5 bits
           .  '<option value="5"';
        if($plugin_cf['memberpages']['accessmode']=="5") $o .=' selected';
        $o .= '>'.sprintf($plugin_tx['memberpages']['access_must_match_bitmask'],5)."</option>\n"
           .  "</select>\n"
           .  '</td></tr>';

        // choose number of available level in access options same and same+lower
        $access_levels_display = ($plugin_cf['memberpages']['accessmode']=="1" || $plugin_cf['memberpages']['accessmode']=="2")
                               ? 'style="display:table-row;"':'style="display:none;"';
        $o .= '<tr id="access_levels" '.$access_levels_display.'><td>' . $plugin_tx['memberpages']['access_levels'] . '</td><td>'
           .  tag('input type="text" style="width:2em;text-align:center;" name="selectable_levels" value="'.$plugin_cf['memberpages']['selectable_levels'].'" ')
           .  '</td></tr>'

        // what to do on login. logout or error
           .  '<tr><td>&nbsp;</td><td>&nbsp;</td></tr><tr><td>'
           .  $plugin_tx['memberpages']['config_on_login'] . '</td><td>' . "\n";
        $pages_select = '';
        for ($i=0;$i<$cl;$i++) {
            $levelindicator = '';
            for ($j=1;$j<$l[$i];$j++) {$levelindicator .= '&ndash;&nbsp;';}
            $page = $levelindicator.$h[$i];
            $selected = '';
            if($plugin_tx['memberpages']['page_on_login'] == $u[$i]) {$selected = ' selected';}
            $pages_select .= "\n".'<option value="' . $u[$i] . '"' . $selected.'>'
                          . $plugin_tx['memberpages']['config_use_special_page'].':&nbsp; '. $page.'</option>';
        }
        $o .= '<select name="page_on_login">'
           .  "\n" . '<option value="">' . $plugin_tx['memberpages']['config_notice_above_loginfield'] . '</option>' . "\n"
           .  "\n" . $pages_select . "\n</select>";

        $o .= '</td></tr><tr><td>'

           .  $plugin_tx['memberpages']['config_on_logout'] . '</td><td>' . "\n";
        $pages_select = '';
        for ($i=0;$i<$cl;$i++) {
            $levelindicator = '';
            for ($j=1;$j<$l[$i];$j++) {$levelindicator .= '&ndash;&nbsp;';}
            $page = $levelindicator.$h[$i];
            $selected = '';
            if($plugin_tx['memberpages']['page_on_logout'] == $u[$i]) {$selected = ' selected';}
            $pages_select .= "\n".'<option value="' . $u[$i] . '"' . $selected.'>'
                          . $plugin_tx['memberpages']['config_use_special_page'].':&nbsp; '.$page.'</option>';
        }
        $o .= '<select name="page_on_logout">'
           .  "\n" . '<option value="">' . $plugin_tx['memberpages']['config_no_special_page'] . '</option>'
           .  "\n" . $pages_select . "\n</select>";

        $o .= '</td></tr><tr><td>'

           .  $plugin_tx['memberpages']['config_on_error'] . '</td><td>' . "\n";
        $pages_select = '';
        for ($i=0;$i<$cl;$i++) {
            $levelindicator = '';
            for ($j=1;$j<$l[$i];$j++) {$levelindicator .= '&ndash;&nbsp;';}
            $page = $levelindicator.$h[$i];
            $selected = '';
            if($plugin_tx['memberpages']['page_on_error'] == $u[$i]) {$selected = ' selected';}
            $pages_select .= "\n".'<option value="' . $u[$i] . '"' . $selected.'>'
                          . $plugin_tx['memberpages']['config_use_special_page'].':&nbsp; '.$page.'</option>';
        }
        $o .= '<select name="page_on_error">'
           .  "\n" . '<option value="">' . $plugin_tx['memberpages']['config_no_special_page'] . '</option>' . "\n"
           .  "\n" . $pages_select . "\n</select>";

        $o .= '</td></tr><tr><td>'

           .  $plugin_tx['memberpages']['config_on_expired'] . '</td><td>' . "\n";
        $pages_select = '';
        for ($i=0;$i<$cl;$i++) {
            $levelindicator = '';
            for ($j=1;$j<$l[$i];$j++) {$levelindicator .= '&ndash;&nbsp;';}
            $page = $levelindicator.$h[$i];
            $selected = '';
            if($plugin_tx['memberpages']['page_on_expired'] == $u[$i]) {$selected = ' selected';}
            $pages_select .= "\n".'<option value="' . $u[$i] . '"' . $selected.'>'
                          . $plugin_tx['memberpages']['config_use_special_page'].':&nbsp; '.$page.'</option>';
        }
        $o .= '<select name="page_on_expired">'
           .  "\n" . '<option value="">' . $plugin_tx['memberpages']['config_no_special_page'] . '</option>' . "\n"
           .  "\n" . $pages_select . "\n</select>";

        // color for M-tab in pagedata tabs if page is memberpage
        $pdtab_color_select = ($plugin_cf['memberpages']['pdtab'])
                            ? 'style="display:table-row;"':'style="display:none;"';

        $o .= '<tr><td>&nbsp;</td><td>&nbsp;</td></tr><tr id="pdtab_color_select" '. $pdtab_color_select.'><td>'
           .  $plugin_tx['memberpages']['config_color_m_tab'] . '</td><td>' . "\n";
        $select = '';
        $x = 0;
        foreach (array('Blue','Green','Magenta','Purple','Red','DeepPink','DarkOrange','Yellow','White') as $key=>$value) {
            $selected = '';
            if($plugin_cf['memberpages']['color_pagedata_tab'] == $value) {$selected = ' selected';$x++;}
            $select .= "\n".'<option value="' . $value . '"' . $selected.'>'. $value.'</option>';
        }
        if(!$x) $select = "\n".'<option value="'
                        . $plugin_cf['memberpages']['color_pagedata_tab']
                        . '" selected>'
                        . $plugin_cf['memberpages']['color_pagedata_tab']
                        . '</option>'
                        . $select;

        $o .= '<select name="pdtabcolor">'
           .  "\n" . $select . "\n</select>";


        $o .= '</td></tr></table>' . "\n";


        $o .= tag('br')
           .  tag('input type="hidden" name="admin" value="'.$admin.'"')
           .  tag('input type="hidden" name="action" value="save"').' '

           //======= save settings ==========
           .  tag('input type="submit" value=" &nbsp; '.$plugin_tx['memberpages']['save_settings'].' &nbsp; "').'</form>' . "\n";

//        $o .= tag('br').'<p><small><a href="?&amp;'.$plugin.'&amp;admin=plugin_config&action=filestorage" />&mdash;&gt; ' .$plugin_tx[$plugin]['menu_file_storage'].'</a></small></p>';

    }



###################################################################################################

    // action on selecting "File"
    //======================================
    if(isset($admin) && $admin == 'plugin_config' and $action == 'filestorage')
    {

        // headline log/config
        $o .= '<h1>'.$plugin_tx['memberpages']['menu_file'].'</h1>' . "\n";

        if(isset($_POST['membersfilesettings'])) {

            $mp_phpfile     = isset($_POST['phpfile'])     ? $_POST['phpfile']     : $plugin_cf['memberpages']['phpfile'];
            $mp_csvfile     = isset($_POST['csvfile'])     ? $_POST['csvfile']     : $plugin_cf['memberpages']['csvfile'];
            $mp_usecsvfile  = isset($_POST['usecsvfile'])  ? $_POST['usecsvfile']  : $plugin_cf['memberpages']['usecsvfile'];


            $configfile = file_get_contents($pth['folder']['plugins'].'/memberpages/config/config.php');

            $configfile = preg_replace('!(\'usecsvfile\'\]=\")(.*)(\";)!','${1}'.$mp_usecsvfile.'${3}',$configfile);
            $configfile = preg_replace('!(\'csvfile\'\]=\")(.*)(\";)!','${1}'.$mp_csvfile.'${3}',$configfile);
            $configfile = preg_replace('!(\'phpfile\'\]=\")(.*)(\";)!','${1}'.$mp_phpfile.'${3}',$configfile);

            file_put_contents($pth['folder']['plugins'].'/memberpages/config/config.php',$configfile);
            include($pth['folder']['plugins'].'/memberpages/config/config.php');
        }

        // download members list
        if(isset($_POST['downloadmemberslist']))
        {
            //downloading a .htaccess protected file
            header('Content-Description: File Transfer');
            header('Content-Type: application/octet-stream');
            header('Content-Disposition: attachment; filename="members.csv"');
            header('Content-Transfer-Encoding: binary');
            header('Content-Length: ' . filesize($csvmemberslist));
            ob_clean();
            readfile($csvmemberslist);
            //now show the original starting page again
            header('Location: '.CMSIMPLE_URL.'?&memberpages&admin=plugin_main');
            exit;
        }

        // start the form
        $o .= '<form action="" method="post">' . "\n";

        if($plugin_cf['memberpages']['usecsvfile']) {
            // information for the webmaster
            $o .= '<p>' . $plugin_tx['memberpages']['memberslist_csv'] . ':</p>'
               .  '<p>' . tag('input type="text" size="60" name="csvfile" value="'.$plugin_cf['memberpages']['csvfile'] .'"')
               .  '</p>';

            if(is_file(substr($pth['folder']['base'].$plugin_cf['memberpages']['csvfile'],0,strrpos($pth['folder']['base'].$plugin_cf['memberpages']['csvfile'],'/'))
                . '/.htaccess')) {

                $o .= '<p>' . $plugin_tx['memberpages']['memberslist_htaccess'] . '</p>' . "\n";
            } else {
                $o .= '<p>' . $plugin_tx['memberpages']['memberslist_no_htaccess'] . '</p>' . "\n";
            } 

        } else {
            $o .= '<p>'.$plugin_tx['memberpages']['memberslist_php'] .':</p>'
               .  '<p>' . tag('input type="text" size="60" name="phpfile" value="'.$plugin_cf['memberpages']['phpfile'] .'"')
               .  '</p>';
        }

        // submit for changes in members list path
        $o .= tag('input type="submit" name="membersfilesettings" value=" &nbsp; '.$plugin_tx['memberpages']['save_settings'].' &nbsp; "');

       // use csv or php list? Always visible
        $o .= tag('input type="hidden" name="membersfilesettings"')
           .  '<p>';
        $o .= $plugin_cf['memberpages']['usecsvfile']
            ? '<button value="0" name="usecsvfile">'.$plugin_tx['memberpages']['config_change_to_php_list']
            : '<button value="1" name="usecsvfile">'.$plugin_tx['memberpages']['config_change_to_csv_list'];
        $o .= '</button></p>'.'</form>' . "\n";

        $o .= tag('br') ;

        // only if members list is csv file
        if($plugin_cf['memberpages']['usecsvfile']) {

            // download csv file members list
            if(is_file($pth['folder']['base'].$plugin_cf['memberpages']['csvfile'])) {
                $o .= '<form action="" method="post">'
                   .  '<p>'
                   .  tag('input type="submit" value="'
                   .  $plugin_tx['memberpages']['memberslist_download']
                   .  '" name="downloadmemberslist"') . '</p></form>' . "\n";
            }
            $o .= tag('br') ;


           //upload csv file members list
           $o .= '<form action="'.$sn.'?&memberpages&admin=plugin_config&action=memberslistupload" method="post" enctype="multipart/form-data">'
              .  tag('input type="submit" value="'.$plugin_tx['memberpages']['memberslist_addtocsv'].'"')
              .  tag('br')
              .  tag('br')
              .  tag('input type="submit" value="'.$plugin_tx['memberpages']['memberslist_upload'].'"')
              .  tag('input type="hidden" name="MAX_FILE_SIZE" value="30000"')
              .  tag('input type="file" name="userfile" id="fileinput" size="50"')
              .  '</form>' . "\n";
        }
    }


###################################################################################################

    // action on uploading a csv-file as members list
    //=================================================
    if(isset($admin) && $admin == 'plugin_config' and $action == 'memberslistupload')
    {
        $phpfile = '';
        if(is_file($pth['folder']['base'].$plugin_cf['memberpages']['phpfile'])) {
            include_once($pth['folder']['base'].$plugin_cf['memberpages']['phpfile']);
            $u1 = explode(",", $members['user_array']);
            $p1 = explode(",", $members['pass_array']);
            $a1 = explode(",", $members['accesslevel_array']);
            $e1 = explode(",", $members['email_array']);
            $f1 = explode(",", $members['fullname_array']);
            $g1 = explode(",", $members['expires_array']);
            foreach ($u1 as $key=>$value) {
                $phpfile .= $u1[$key] . ',' . $p1[$key] . ',' . $a1[$key] . ',' . $e1[$key] . ',' . $f1[$key] . ',' . $g1[$key]. "\n";
            }
        }

        $restore = isset($_POST['restore']) ? $_POST['restore'] : $restore = isset($_GET['restore']) ? $_GET['restore'] : '';
        if($restore == 1) //restore backup csv file
        {
            if(is_file($csvmemberslist)) {
                $fp = fopen ($csvmemberslist , "r+");
                fclose ($fp);
                unlink($pth['folder']['base'].$plugin_cf['memberpages']['csvfile']);
            }
            rename($csvmemberslist.'.bak',$csvmemberslist);
            $uploadfile = '';
        }
        elseif($restore == 2) //add php data to csv file
        {
            $oldlist = file_get_contents($csvmemberslist);
            $fp = fopen ($csvmemberslist , "w");
            if(trim($oldlist) && trim($phpfile)) {
                fwrite($fp,trim($oldlist)."\n".trim($phpfile));
            } else {
                fwrite($fp,trim($oldlist).trim($phpfile));
            }
            fclose ($fp);
            $uploadfile = '';
        }
        else
        {
        $notice = '';

        $uploadfile = $csvmemberslist .'.temp';

        if (move_uploaded_file($_FILES['userfile']['tmp_name'], $uploadfile)) {
            $notice .= $plugin_tx['memberpages']['upload_successful'] . tag('br');
        } else {
            $notice .=  $plugin_tx['memberpages']['upload_problem'] . tag('br');
        }

        $o .= $notice .= $plugin_tx['memberpages']['upload_filename'].': '
           .  $_FILES['userfile']['name'] . tag('br')
           .  $plugin_tx['memberpages']['upload_filesize'] . ': ' . $_FILES['userfile']['size'] .' bytes';

        $o .= "<form method='POST' style='margin:.5em auto;text-align:center;' action='".$sn."?&memberpages&admin=plugin_config&action=replacecsv'>"
           .  tag("input type='submit' value='".$plugin_tx['memberpages']['config_replace_csvfile']."'")
           .  "</form>\n";
        }


        $newfile = is_file($uploadfile)?
                   nl2br(file_get_contents($uploadfile))
                   : $plugin_tx['memberpages']['config_no_file_found'];

        $oldfile = is_file($pth['folder']['base'].$plugin_cf['memberpages']['csvfile'])?
                   nl2br(file_get_contents($pth['folder']['base'].$plugin_cf['memberpages']['csvfile']))
                   : $plugin_tx['memberpages']['config_no_file_found'];


        $backupfile = is_file($csvmemberslist . '.bak')?
                      nl2br(file_get_contents($csvmemberslist . '.bak'))
                      : $plugin_tx['memberpages']['config_no_file_found'];
        $backupfile = $backupfile? $backupfile : $plugin_tx['memberpages']['config_no_file_found'];

        $displayphpfile = $phpfile? nl2br($phpfile) : $plugin_tx['memberpages']['config_no_data_found'];

        $o .= '<table class="mpp_filemanipulation">'
           .  '<tr><th style="width:50%;">'
           .  $plugin_tx['memberpages']['config_old_file']
           .  '</th><th style="width:50%;">'
           .  $plugin_tx['memberpages']['config_uploaded_file']
           .  "</th></tr><td>$oldfile</td><td>$newfile</td></tr>"
           .  '<tr><th>'
           .  "<form method='POST' action='".$sn."?&memberpages&admin=plugin_config&action=memberslistupload&restore=1'>"
           .  $plugin_tx['memberpages']['config_backup_file'] . ' '
           .  tag("input type='submit' value='".$plugin_tx['memberpages']['config_restore_csvfile']."'")
           .  '</form>'."\n"
           .  '</th><th>'
           .  "<form method='POST' action='".$sn."?&memberpages&admin=plugin_config&action=memberslistupload&restore=2'>"
           .  $plugin_tx['memberpages']['config_php_members_file'] . ' '
           .  tag('input type="submit" value="'.$plugin_tx['memberpages']['config_add_php_to_csvfile'].'"')
           .  '</form>'."\n"
           .  '</th></tr><tr><td>'.$backupfile.'</td><td>'.$displayphpfile.'</td></tr>'
           .  '</table>'."\n";
    }

###################################################################################################

    // action on clicking replace old file
    //======================================
    if(isset($admin) && $admin == 'plugin_config' and $action == 'replacecsv')
    {
    // in case the file handle hasn't been closed
        $fp = fopen ($pth['folder']['base'].$plugin_cf['memberpages']['csvfile'] , "r+");
        fclose ($fp);

        if(is_file($csvmemberslist.'.bak')) unlink($csvmemberslist.'.bak');
        rename($csvmemberslist,$csvmemberslist.'.bak');
        if(rename($csvmemberslist .'.temp',$csvmemberslist)) {
            header('Location: '.CMSIMPLE_URL.'?&memberpages&admin=plugin_main');
            exit;

        } else {
            $o .= 'Sorry, unable to install uploaded file';
        }
    }


###################################################################################################

    // action on changing anything in the members list
    //=================================================
    if($admin == 'plugin_main' && $action == 'memberslist' && !isset($_POST['activate_memberpages'])) $o .= memberpagesSaveList ();


###################################################################################################

    // action on saving config data
    //===============================
    if((isset($admin) && $admin == 'plugin_config' and $action == 'save') || isset($_POST['activate_memberpages']))
    {
        //config data
        $memberpages_pdtab              = isset($_POST['pdtab'])
                                        ? $_POST['pdtab']
                                        : $memberpages_pdtab
                                        = (isset($plugin_cf['memberpages']['pdtab']) && $plugin_cf['memberpages']['pdtab'] !== '')
                                        ? $plugin_cf['memberpages']['pdtab']
                                        : 1 ;
        $memberpages_texttrigger        = isset($_POST['texttrigger'])
                                        ? $_POST['texttrigger']
                                        : $memberpages_texttrigger
                                        = (isset($plugin_cf['memberpages']['texttrigger']) && $plugin_cf['memberpages']['texttrigger'] !== '')
                                        ? $plugin_cf['memberpages']['texttrigger']
                                        : 0 ;
       $memberpages_selectable_levels   = isset($_POST['selectable_levels'])
                                        ? $_POST['selectable_levels']
                                        : '';
       if($memberpages_selectable_levels === '') {
          $memberpages_selectable_levels = (isset($plugin_cf['memberpages']['selectable_levels']) && $plugin_cf['memberpages']['selectable_levels'] !== '')
                                         ? $plugin_cf['memberpages']['selectable_levels']
                                         : 5 ;
       }

        $memberpages_accessmode         = isset($_POST['accessmode'])
                                        ? $_POST['accessmode']
                                        : '';
       if($memberpages_accessmode === '') {
          $memberpages_accessmode       = (isset($plugin_cf['memberpages']['accessmode']) && $plugin_cf['memberpages']['accessmode'] !== '')
                                        ? $plugin_cf['memberpages']['accessmode']
                                        : 3 ;
       }

        $memberpages_phpfile            = isset($_POST['phpfile'])
                                        ? $_POST['phpfile']
                                        : $memberpages_phpfile
                                        = (isset($plugin_cf['memberpages']['phpfile']) && $plugin_cf['memberpages']['phpfile'])
                                        ? $plugin_cf['memberpages']['phpfile']
                                        : 'plugins/memberpages/data/memberslist.php' ;
        $memberpages_csvfile            = isset($_POST['csvfile'])
                                        ? $_POST['csvfile']
                                        : $memberpages_csvfile
                                        = (isset($plugin_cf['memberpages']['csvfile']) && $plugin_cf['memberpages']['csvfile'])
                                        ? $plugin_cf['memberpages']['csvfile']
                                        : 'plugins/memberpages/data/members.csv' ;
        $memberpages_usecsvfile         = isset($_POST['usecsvfile'])
                                        ? $_POST['usecsvfile']
                                        : $memberpages_usecsvfile
                                        = (isset($plugin_cf['memberpages']['usecsvfile']) && $plugin_cf['memberpages']['usecsvfile'] !== '')
                                        ? $plugin_cf['memberpages']['usecsvfile']
                                        : 1 ;
        $memberpages_defaultpassword    = isset($_POST['memberpages_defaultpassword'])
                                        ? $_POST['memberpages_defaultpassword']
                                        : $memberpages_defaultpassword
                                        = (isset($plugin_cf['memberpages']['memberpages_defaultpassword']) && $plugin_cf['memberpages']['memberpages_defaultpassword'] !== '')
                                        ? $plugin_cf['memberpages']['memberpages_defaultpassword']
                                        : '';
        $memberpages_generatepassword   = isset($_POST['generate_password'])
                                        ? $_POST['generate_password']
                                        : '';
        if($memberpages_generatepassword === '') {
          $memberpages_generatepassword = (isset($plugin_cf['memberpages']['generate_password']) && $plugin_cf['memberpages']['generate_password'] !== '')
                                        ? $plugin_cf['memberpages']['generate_password']
                                        : 2;
        }
        $memberpages_passwordforgotten  = isset($_POST['passwordforgotten'])
                                        ? $_POST['passwordforgotten']
                                        : $memberpages_passwordforgotten
                                        = (isset($plugin_cf['memberpages']['passwordforgotten']) && $plugin_cf['memberpages']['passwordforgotten'] !== '')
                                        ? $plugin_cf['memberpages']['passwordforgotten']
                                        : 0;
        $memberpages_rememberme         = isset($_POST['memberpages_rememberme'])
                                        ? $_POST['memberpages_rememberme']
                                        : $memberpages_rememberme
                                        = (isset($plugin_cf['memberpages']['memberpages_rememberme']) && $plugin_cf['memberpages']['memberpages_rememberme'] !== '')
                                        ? $plugin_cf['memberpages']['memberpages_rememberme']
                                        : 1;
        $memberpages_smalllogin         = isset($_POST['memberpages_smalllogin'])
                                        ? $_POST['memberpages_smalllogin']
                                        : $memberpages_smalllogin
                                        = (isset($plugin_cf['memberpages']['memberpages_smalllogin']) && $plugin_cf['memberpages']['memberpages_smalllogin'] !== '')
                                        ? $plugin_cf['memberpages']['memberpages_smalllogin']
                                        : 0;
        $memberpages_pdtabcolor         = isset($_POST['pdtabcolor'])
                                        ? $_POST['pdtabcolor']
                                        : '';
        if($memberpages_pdtabcolor === '') {
           $memberpages_pdtabcolor      = (isset($plugin_cf['memberpages']['color_pagedata_tab']) && $plugin_cf['memberpages']['color_pagedata_tab'])
                                        ? $plugin_cf['memberpages']['color_pagedata_tab']
                                        : 'blue';
        }
        $memberpages_site_email         = isset($_POST['site_email'])
                                        ? $_POST['site_email']
                                        : $memberpages_site_email
                                        = (isset($plugin_cf['memberpages']['site_email']) && $plugin_cf['memberpages']['site_email'] !== '')
                                        ? $plugin_cf['memberpages']['site_email']
                                        : '';
        $memberpages_email              = isset($_POST['members_email'])
                                        ? $_POST['members_email']
                                        : $memberpages_email
                                        = (isset($plugin_cf['memberpages']['register_email']) && $plugin_cf['memberpages']['register_email'] !== '')
                                        ? $plugin_cf['memberpages']['register_email']
                                        : 1;
        $memberpages_admin_email        = isset($_POST['admin_email'])
                                        ? $_POST['admin_email']
                                        : $memberpages_admin_email
                                        = (isset($plugin_cf['memberpages']['admin_email']) && $plugin_cf['memberpages']['admin_email'] !== '')
                                        ? $plugin_cf['memberpages']['admin_email']
                                        : '';
        $memberpages_show_actives       = phpversion() <5
                                        ? 0
                                        : $memberpages_show_actives
                                        = isset($_POST['show_actives'])
                                        ? $_POST['show_actives']
                                        : $memberpages_show_actives
                                        = (isset($plugin_cf['memberpages']['show_actives']) && $plugin_cf['memberpages']['show_actives'] !== '')
                                        ? $plugin_cf['memberpages']['show_actives']
                                        : 1;
        $memberpages_show_fullname      = isset($_POST['show_fullname'])
                                        ? $_POST['show_fullname']
                                        : $memberpages_show_fullname
                                        = (isset($plugin_cf['memberpages']['show_fullname']) && $plugin_cf['memberpages']['show_fullname'] !== '')
                                        ? $plugin_cf['memberpages']['show_fullname']
                                        : 1;
        $memberpages_show_expires       = isset($_POST['show_expires'])
                                        ? $_POST['show_expires']
                                        : $memberpages_show_expires
                                        = (isset($plugin_cf['memberpages']['show_expires']) && $plugin_cf['memberpages']['show_expires'] !== '')
                                        ? $plugin_cf['memberpages']['show_expires']
                                        : 1;
        $memberpages_controlpanel       = isset($_POST['controlpanel'])
                                        ? $_POST['controlpanel']
                                        : $memberpages_controlpanel
                                        = (isset($plugin_cf['memberpages']['controlpanel']) && $plugin_cf['memberpages']['controlpanel'] !== '')
                                        ? $plugin_cf['memberpages']['controlpanel']
                                        : 1;

        //language data
        $memberpages_page_on_error      = isset($_POST['page_on_error'])
                                        ? $_POST['page_on_error']
                                        : $memberpages_page_on_error
                                        = (isset($plugin_tx['memberpages']['page_on_error']) && $plugin_tx['memberpages']['page_on_error'] !== '')
                                        ? $plugin_tx['memberpages']['page_on_error']
                                        : '';
        $memberpages_page_on_login      = isset($_POST['page_on_login'])
                                        ? $_POST['page_on_login']
                                        : $memberpages_page_on_login
                                        = (isset($plugin_tx['memberpages']['page_on_login']) && $plugin_tx['memberpages']['page_on_login'] !== '')
                                        ? $plugin_tx['memberpages']['page_on_login']
                                        : '';
        $memberpages_page_on_logout     = isset($_POST['page_on_logout'])
                                        ? $_POST['page_on_logout']
                                        : $memberpages_page_on_logout
                                        = (isset($plugin_tx['memberpages']['page_on_logout']) && $plugin_tx['memberpages']['page_on_logout'] !== '')
                                        ? $plugin_tx['memberpages']['page_on_logout']
                                        : '';
        $memberpages_page_on_expired    = isset($_POST['page_on_expired'])
                                        ? $_POST['page_on_expired']
                                        : $memberpages_page_on_expired
                                        = (isset($plugin_tx['memberpages']['page_on_expired']) && $plugin_tx['memberpages']['page_on_expired'] !== '')
                                        ? $plugin_tx['memberpages']['page_on_expired']
                                        : '';

        $languagefile = file_get_contents($pth['folder']['plugins'] . $plugin . "/languages/$sl.php");

        // create language file entries if not there
        $languagefile = !preg_match('!page_on_error\'\]="(.*)";!' ,$languagefile)
                      ? str_replace('?>',"\t".'$plugin_tx[\'memberpages\'][\'page_on_error\']="";'."\n?>" ,$languagefile)
                      : $languagefile;
        $languagefile = !preg_match('!page_on_login\'\]="(.*)";!' ,$languagefile)
                      ? str_replace('?>',"\t".'$plugin_tx[\'memberpages\'][\'page_on_login\']="";'."\n?>" ,$languagefile)
                      : $languagefile;
        $languagefile = !preg_match('!page_on_logout\'\]="(.*)";!',$languagefile)
                      ? str_replace('?>',"\t".'$plugin_tx[\'memberpages\'][\'page_on_logout\']="";'."\n?>",$languagefile)
                      : $languagefile;
        $languagefile = !preg_match('!page_on_expired\'\]="(.*)";!',$languagefile)
                      ? str_replace('?>',"\t".'$plugin_tx[\'memberpages\'][\'page_on_expired\']="";'."\n?>",$languagefile)
                      : $languagefile;

        $pattern = array('!page_on_error\'\]="(.*)";!','!page_on_login\'\]="(.*)";!','!page_on_logout\'\]="(.*)";!','!page_on_expired\'\]="(.*)";!');
        $replacement = array(
            "page_on_error']=\"$memberpages_page_on_error\";",
            "page_on_login']=\"$memberpages_page_on_login\";",
            "page_on_logout']=\"$memberpages_page_on_logout\";",
            "page_on_expired']=\"$memberpages_page_on_expired\";"
            );
        $languagefile = preg_replace($pattern,$replacement,$languagefile);

        file_put_contents($pth['folder']['plugins'] . $plugin . "/languages/$sl.php",$languagefile);
        include ($pth['folder']['plugins'] . $plugin ."/languages/$sl.php");

    // if no site email is there, generate one
    If (!$memberpages_site_email) $memberpages_site_email = $txc['mailform']['email'];
    If (!$memberpages_site_email && $memberpages_passwordforgotten && $GLOBALS['_SERVER']['SERVER_NAME']!='localhost') {
        $memberpages_site_email = 'webmaster@' . $GLOBALS['_SERVER']['SERVER_NAME'] ;
    }

    // if method "#CMSimple member();#" was active and has been unchecked in plugin admin, this checks if it the call is still in the site content
    $mp_e = '';
    if(!$memberpages_texttrigger && $plugin_cf['memberpages']['texttrigger']) {
        $content = file_get_contents($pth['file']['content']);
        if(strpos($content,'member(')!==false) {
            $mp_e .='&error=1';
            $memberpages_texttrigger = '1';
        }
    }

    // if pagedata taps were active and have been made inactive, the pagedata.php has to be cleaned
    if(!$memberpages_pdtab && $plugin_cf['memberpages']['pdtab']) {

        $key  = array_search('mpage', $pd_router->model->params);
        $key2 = array_search('mplevel', $pd_router->model->params);
        if ($key  !== FALSE) {unset($pd_router->model->params[$key]);}
        if ($key2 !== FALSE) {unset($pd_router->model->params[$key2]);}
        for ($i = 0; $i < count($pd_router->model->data); $i++) {
        unset($pd_router->model->data[$i]['mpage']);
        unset($pd_router->model->data[$i]['mplevel']);
        }
        unset($pd_router->model->temp_data['mpage']);
        unset($pd_router->model->temp_data['mplevel']);
        $pd_router->model->save();
    }

        $text = "<?php\n\n"
              . '$plugin_cf[\'memberpages\'][\'version\']="3.4.1";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'pdtab\']="' .            $memberpages_pdtab            . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'texttrigger\']="' .      $memberpages_texttrigger      . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'usecsvfile\']="' .       $memberpages_usecsvfile       . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'csvfile\']="' .          $memberpages_csvfile          . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'phpfile\']="' .          $memberpages_phpfile          . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'default_password\']="' . $memberpages_defaultpassword  . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'generate_password\']="'. $memberpages_generatepassword . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'accessmode\']="' .       $memberpages_accessmode       . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'selectable_levels\']="'. $memberpages_selectable_levels. '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'passwordforgotten\']="'. $memberpages_passwordforgotten. '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'rememberme\']="' .       $memberpages_rememberme       . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'small_login\']="' .      $memberpages_smalllogin       . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'color_pagedata_tab\']="'.$memberpages_pdtabcolor       . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'register_email\']="'  .  $memberpages_email            . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'site_email\']="' .       $memberpages_site_email       . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'admin_email\']="' .      $memberpages_admin_email      . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'show_actives\']="' .     $memberpages_show_actives     . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'show_fullname\']="' .    $memberpages_show_fullname    . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'show_expires\']="' .     $memberpages_show_expires     . '";' . "\n"
              . '$plugin_cf[\'memberpages\'][\'controlpanel\']="'  .    $memberpages_controlpanel     . '";' . "\n\n"
              . '?>';
        file_put_contents($pth['folder']['plugins'] . $plugin . "/config/config.php",$text);

        if(isset($_POST['activate_memberpages'])) memberpagesSaveList();

        header('Location: '.CMSIMPLE_URL.'?&memberpages&admin=plugin_config&action=plugin_edit'.$mp_e);
        exit;

    }
}
?>
