<?php
/**
 * @package	Memberpages
 * @copyright	Copyright (c) 2012-2013 svasti (Frank Ziesing) <http://frankziesing.de/cmsimple/>
 * @license	http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 * @version     3.4
 * @link	http://frankziesing.de/cmsimple/?Start:Memberpages
 *
 * utf-8 check: äöüß
 * for history see changelog.txt
 */

if ((!function_exists('sv')) || preg_match('!admin.php!i', sv('PHP_SELF')))die('Access denied');

if (!defined('CMSIMPLE_URL')) {
    define('CMSIMPLE_URL', 'http'
       . (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off' ? 's' : '')
       . '://' . $_SERVER['SERVER_NAME']
       . ($_SERVER['SERVER_PORT'] < 1024 ? '' : ':' . $_SERVER['SERVER_PORT'])
       . preg_replace('/index.php$/', '', $_SERVER['SCRIPT_NAME']));
}

include_once 'memberlist.php';

if (preg_match("!Googlebot!i",$_SERVER['HTTP_USER_AGENT']));
else if (preg_match("!MSNbot!i",$_SERVER['HTTP_USER_AGENT']));
else if (preg_match("!slurp!i",$_SERVER['HTTP_USER_AGENT']));
else if (!isset($_SESSION)) {session_start();}
@header("Cache-Control: no-cache, must-revalidate");
$plugin = basename(dirname(__FILE__),"/");
$secret_word = "cmsimpleplugins";

//if php 4 is used, this function has to be supplied (by cmb)
if (!function_exists('file_put_contents')) {
    function file_put_contents($filename, $data) {
        $f = @fopen($filename, 'w');
        if (!$f) {
            return false;
        } else {
        if (is_array($data)) {$data = implode('', $data);}
            $bytes = fwrite($f, $data);
            fclose($f);
            return $bytes;
        }
    }
}

//get memberslist
if($plugin_cf['memberpages']['usecsvfile'])
{
    $csvmemberslist = $pth['folder']['base'] . $plugin_cf['memberpages']['csvfile'];

    $user_array = $expireduser_array = $pass_array = $expiredpass_array = $accesslevel_array = $email_array = $fullname_array = $expires_array = array();

    $csv_array = file($csvmemberslist);

    foreach($csv_array as $key => $value) {
        $data = explode(',', $csv_array[$key]);
        if($plugin_cf['memberpages']['show_expires'] && isset($data[5]) && trim($data[5]) && trim($data[5]) < date('Y-m-d')) {
            array_push($expireduser_array, $data[0]);
            array_push($expiredpass_array, $data[1]);
        } else {
            array_push($user_array,        $data[0]);
            array_push($pass_array,        $data[1]);
            array_push($accesslevel_array, $data[2]);
            if(!isset($data[3]))           $data[3] = '';
            array_push($email_array,       trim($data[3]));
            if($plugin_cf['memberpages']['show_actives'] && $plugin_cf['memberpages']['show_fullname']) {
                if(!isset($data[4]))           $data[4] = '';
                array_push($fullname_array, trim($data[4]));
            }
        }
    }
    // print_r($expireduser_array);
}
else
{
    $memberslist = $pth['folder']['base'] . $plugin_cf['memberpages']['phpfile'];
    if($plugin_cf['memberpages']['version'] && !@include($memberslist)) {
        $e .= '<li><b>'.$plugin_tx['memberpages']['error_memberlist_missing'].'.</b> ('
           .  $plugin_tx['memberpages']['error_try'] .': "' . $plugin_tx['memberpages']['memberslist_save'] . '")</li>';
    }

    $user_array        = explode(",", $members['user_array']);
    $pass_array        = explode(",", $members['pass_array']);
    $accesslevel_array = explode(",", $members['accesslevel_array']);
    $email_array       = explode(",", $members['email_array']);
    if($plugin_cf['memberpages']['show_actives'] && $plugin_cf['memberpages']['show_fullname']) {
        $fullname_array = explode(",", $members['fullname_array']);
    }

    if($plugin_cf['memberpages']['show_expires']) {
        $expires_array     = explode(",", $members['expires_array']);
        $expireduser_array = $expiredpass_array = array();

        foreach ($user_array as $key=>$value) {
            if(trim($expires_array[$key]) && trim($expires_array[$key]) < date('Y-m-d')) {
                $expireduser_array[] = $user_array[$key];
                $expiredpass_array[] = $pass_array[$key];
                unset($user_array[$key],$pass_array[$key],$accesslevel_array[$key],$email_array[$key],$expires_array[$key]);
                if($plugin_cf['memberpages']['show_actives'] && $plugin_cf['memberpages']['show_fullname']) {
                    unset($fullname_array[$key]);
                }
            }
        }
    }
}

###################################################################################################

if($plugin_cf['memberpages']['pdtab']) {

    // Add used interests to router
    $pd_router -> add_interest('mpage');
    $pd_router -> add_interest('mplevel');

    // tab for admin-menu
    $pd_router -> add_tab('M', $pth['folder']['plugins'].'memberpages/memberpages_view.php');



// MAIN PLUGIN-FUNCTION: hide memberpages unless a member is logged in or CMS is in edit or adm mode

    if(!$adm OR ($adm && !$edit))
    {
        $pages = $pd_router -> find_all();
        foreach($pages as $i => $values)
        {
            if(isset($values['mpage']) && $values['mpage'])
            {
                if($values['mplevel'])
                {
                    $access_level = $values['mplevel'];

                    if(!$plugin_cf['memberpages']['accessmode'])
                    {
                        if(!isset($_SESSION['accesslevel']))
                        {
                            $c[$i] = '#CMSimple hide#';
                        }
                    }
                    elseif($plugin_cf['memberpages']['accessmode']==1)
                    {
                        if(!isset($_SESSION['accesslevel'])
                           || $_SESSION['accesslevel'] < $access_level)
                        {
                            $c[$i] = '#CMSimple hide#';
                        }
                    }
                    elseif($plugin_cf['memberpages']['accessmode']==2)
                    {
                        if(!isset($_SESSION['accesslevel'])
                             || $_SESSION['accesslevel'] != $access_level)
                        {
                            $c[$i] = '#CMSimple hide#';
                        }
                    }
                    elseif($plugin_cf['memberpages']['accessmode'] > 2)
                    {
                        if(!isset($_SESSION['accesslevel'])
                           || !($_SESSION['accesslevel'] & pow(2,$access_level-1)))
                        {
                            $c[$i] = '#CMSimple hide#';
                        }
                    }
                }
                else
                {
                    if(!isset($_SESSION['accesslevel']))
                    {
                        $c[$i] = '#CMSimple hide#';
                    }
                }
            }
        }
    }

}


// OLD STYLE hiding of memberpages via text trigger #CMSimple member();#
//-----------------------------------------------------------------------
if($plugin_cf['memberpages']['texttrigger']) {

    if(!($edit && $adm))
    {
    	for($i = 0; $i < $cl; $i++)
    	{
            if(strpos($c[$i],'member('))
    		{
                if (preg_match('!(?:#CMSimple |{{{PLUGIN:)member\((.*?)\);(?:#|}}})!i',$c[$i],$matches))
                {
                    if(trim($matches[1],"\"'"))
                    {
                        $access_level = trim($matches[1],"\"'");

                        if(!$plugin_cf['memberpages']['accessmode'])
                        {
                			if(!isset($_SESSION['accesslevel']))
                			{
                				$c[$i] = '#CMSimple hide#';
                			}
                        }
                        elseif($plugin_cf['memberpages']['accessmode']==1)
                        {
                			if(!isset($_SESSION['accesslevel'])
                               || $_SESSION['accesslevel'] < $access_level)
                			{
                				$c[$i] = '#CMSimple hide#';
                			}
                        }
                        elseif($plugin_cf['memberpages']['accessmode']==2)
                        {
                			if(!isset($_SESSION['accesslevel'])
                                 || $_SESSION['accesslevel'] != $access_level)
                			{
                				$c[$i] = '#CMSimple hide#';
                			}
                        }
                        elseif($plugin_cf['memberpages']['accessmode'] > 2)
                        {
                			if(!isset($_SESSION['accesslevel'])
                               || !($_SESSION['accesslevel'] & pow(2,$access_level-1)))
                			{
                                $c[$i] = '#CMSimple hide#';
                			}
                        }
                    }
                    else
                    {
                		if(!isset($_SESSION['accesslevel']))
                		{
                			$c[$i] = '#CMSimple hide#';
                		}
                    }
        		}
            }
    	}
    }
}



###################################################################################################

// automatic log in

if($plugin_cf['memberpages']['rememberme'])
{
    if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
    {
        if(!isset($_SESSION['username']))$function='memberslogin';
    }
}

###################################################################################################

// PASSWORD FORGOTTEN

initvar('passwordforgotten');
if($passwordforgotten)
{
   $function = ''; 

    // ========================= Sending the password =========================

    if(isset($_POST['sendpassword']))
    {
        $passwordforgotten_name    = isset($_POST['passwordforgotten_name'])  ? $_POST['passwordforgotten_name']    : '';

        $found_key = false;
        $logfilenotice = '';
        foreach ($user_array as $key => $value) {
            if( $passwordforgotten_name == $user_array[$key]
                and $passwordforgotten_name
                and $user_array[$key]
                and $email_array[$key]) {
                $found_key = $key;
                break;
            }
        }
        // prepare sending of mail
        if($found_key!==false) {
            $to = $email_array[$found_key];
            $message = sprintf($plugin_tx['memberpages']['passwordforgotten_email_message'], $user_array[$found_key],$GLOBALS['_SERVER']['SERVER_NAME'],$pass_array[$found_key]);
        } else {
        // in case no member's email or no member's name was found
            $logfilenotice .= "password asked by $passwordforgotten_name, data not found\n";
            // send mail to site address/webmaster
            $to = $plugin_cf['memberpages']['admin_email']
                ? $plugin_cf['memberpages']['admin_email']
                : $plugin_cf['memberpages']['site_email'];

            $message = sprintf($plugin_tx['memberpages']['passwordforgotten_webmaster_inform'], $passwordforgotten_name);
        }

        $subject = '=?UTF-8?B?'.base64_encode($plugin_tx['memberpages']['passwordforgotten_email_subject']).'?=';
        $header = "MIME-Version: 1.0\r\nContent-type: text/plain; charset=UTF-8\r\nFrom: "
                    . $plugin_cf['memberpages']['site_email'];

        if(mail($to,$subject,$message,$header)) {

            $o .= '<div class="mpp_message">';
            $o .= $found_key!==false
               ? $plugin_tx['memberpages']['passwordforgotten_send']
               : $plugin_tx['memberpages']['passwordforgotten_webmaster_contacted'] ;
            $o .= '</div>';

            $logfilenotice .= $found_key!==false
                ? "password send to $user_array[$found_key] at $email_array[$found_key] "
                : "password request by $passwordforgotten_name sent to $to ";

        } else {

            $o = '<div class="mpp_message">'. $plugin_tx['memberpages']['passwordforgotten_could_not_send'] . '</div>';
            $logfilenotice .= "password asked by $passwordforgotten_name, mailfunction failed ";
        }

        // writing to log file
        if($logfilenotice)
        {
            $logfile = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', 'a');
            fwrite($logfile, date("Y-m-d H:i:s") . ' ' . $logfilenotice . "\n");
        }
    }

    //================================ Form to ask for the password ======================================
    else
    {
       $o = '<div class="mpp_message" id="passwordforgotten">'.$plugin_tx['memberpages']['notice_password_forgotten']
          . '<form action="" method="post">'
          . tag('input type="hidden" name="passwordforgotten" value="sendpassword"')
          . tag('input type="hidden" name="sendpassword" value="1"')

          . '<table class="mpp_memberspanel">'

          . '<tr>'
          . '<td style="text-align:center">'
          . $plugin_tx['memberpages']['passwordforgotten_name']
          . ' </td><td>'
          . tag('input type="text" name="passwordforgotten_name" value=""')
          . '</td>'
          . '</tr>' . "\n"

          . '<tr><td>&nbsp;</td><td>&nbsp;</td></tr>'

          . '<tr><td colspan="2">'
          . $plugin_tx['memberpages']['passwordforgotten_text']
          . "</td></tr>\n"

          . '<tr><td>'
          . tag('input type="button" value="'.$plugin_tx['memberpages']['close_without_saving'].'"
               onclick="document.getElementById(\'passwordforgotten\').style.display = \'none\';"')
          . ' </td><td>'
          . tag('input type="submit" name="submit" value="'.$plugin_tx['memberpages']['passwordforgotten_send_password'].'"')
          . '</td>'
          . '</tr>'
          . "\n"

          . '</table>'
          . "\n"
          . '</form>'
          . "\n"
          . '</div>';
    }
}

###################################################################################################


// LOGIN

if($function=='memberslogin')
{
    $loginpassed = FALSE;
    initvar('username');
    initvar('password');
    if($plugin_cf['memberpages']['show_fullname']) initvar('fullname');
    if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
    {
        $username = $_COOKIE['cookname'];
        $password_hash = $_COOKIE['cookpass'];
    }
    else
    {
        $password_hash = md5($secret_word.$password);
    }

    foreach ($user_array as $i=>$value) {

        if($username == $user_array[$i] && $password_hash == md5($secret_word . $pass_array[$i])) {

            if(isset($_POST['remember'])) {
                $password_hash = md5($secret_word . $password);
                setcookie("cookname", $username, time()+60*60*24*100, "/");
                setcookie("cookpass", $password_hash, time()+60*60*24*100, "/");
            }
            $_SESSION['accesslevel'] = $accesslevel_array[$i];
            $_SESSION['username'] = $username;
            $_SESSION['password'] = $password;
            if($plugin_cf['memberpages']['show_fullname']) $_SESSION['fullname'] = $fullname_array[$i]? $fullname_array[$i] : $username;

            $logfile = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', 'a');
            fwrite($logfile, date("Y-m-d H:i:s") . " $username logged in" . "\n");

            $loginpassed = TRUE;

            //If a login_page is defined use it
            if($plugin_tx['memberpages']['page_on_login']) {
                header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_on_login']);
                exit;

            } else {
                header('Location: '.CMSIMPLE_URL.'?'.$su);
                exit;
            }
        }
    }
    if(!$loginpassed && $plugin_cf['memberpages']['show_expires']) {

        foreach ($expireduser_array as $i=>$value) {

            if($username == $expireduser_array[$i] && $password_hash == md5($secret_word . $expiredpass_array[$i])) {

                if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
                {
                    setcookie("cookname", "", time()-60*60*24*100, "/");
                    setcookie("cookpass", "", time()-60*60*24*100, "/");
                }

                $logfile = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', 'a');
                fwrite($logfile, date("Y-m-d H:i:s") . " $username rejected: membership expired" . "\n");

                $loginpassed = TRUE;

                //If an expired page is defined use it
                if($plugin_tx['memberpages']['page_on_expired']) {
                    header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_on_expired']);
                    exit;

                } else {
                    $o='<div class="mpp_message">'.$plugin_tx['memberpages']['notice_membership_expired'].'</div>';
                }
            }
        }
    }

    if(!$loginpassed) {

        if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
        {
            setcookie("cookname", "", time()-60*60*24*100, "/");
            setcookie("cookpass", "", time()-60*60*24*100, "/");
        }

        $logfile = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', 'a');
        fwrite($logfile, date("Y-m-d H:i:s") . ' "'. $username . '" wrong name/password' . "\n");

        //If an error_page is defined, use it
        if($plugin_tx['memberpages']['page_on_error'])
        {
            header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_on_error']);
            exit;
        }
        //else give an error message
        else
        {
            $o='<div class="mpp_message">'.$plugin_tx['memberpages']['notice_login_error'].'</div>';
        }
    }
}

###################################################################################################

// LOGOUT

if($function=='memberslogout')
{
    $username = isset($_SESSION['username'])? $_SESSION['username'] : '???';
    unset($_SESSION['username'], $_SESSION['accesslevel'], $_SESSION['password'], $_SESSION['fullname']);
    if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookpass']))
    {
        setcookie("cookname", "", time()-60*60*24*100, "/");
        setcookie("cookpass", "", time()-60*60*24*100, "/");
    }

    $logfile = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', 'a');
    fwrite($logfile, date("Y-m-d H:i:s") . " $username logged out" . "\n");


//If a logout_page is defined, use it
    if($plugin_tx['memberpages']['page_on_logout'])
    {
        header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_on_logout']);
        exit;
    }
//else give a message
    else
    {
        $o='<div class="mpp_message">'.$plugin_tx['memberpages']['notice_logged_out'].'</div>';
    }
}

###################################################################################################

// Members Control Panel for changing password and email address

if($function=='memberspanel' && $plugin_cf['memberpages']['controlpanel'])
{
    // ======================== processing received changes =================================
    if(isset($_POST['memberspanel']))
    {
        $successfulchange = $nochange = false;
        $not_ok_detail = '';

        $oldpassword    = isset($_POST['oldpassword'])  ? stsl($_POST['oldpassword'])       : '';
        $newpassword    = isset($_POST['newpassword'])  ? stsl($_POST['newpassword'])       : '';
        $newpassword2   = isset($_POST['newpassword2']) ? stsl($_POST['newpassword2'])      : '';
        $newemail       = isset($_POST['newemail'])     ? trim(stsl($_POST['newemail']))    : '';
        $newfullname    = isset($_POST['newfullname'])  ? str_replace('"','',trim(stsl($_POST['newfullname']))) : '';

        $pw_found          = $oldpassword? true : false;

        $pw_wrong          = ($pw_found && $_SESSION['password'] && $_SESSION['password'] != $oldpassword)? true : false;

        $newpw_notmatching = ($newpassword && $newpassword != $newpassword2)? true : false;

        $newpw_not_ok      = ($newpassword && !preg_match('!^[^\s,\"\\\\]{5,}$!',$newpassword))? true : false;
        if($newpw_not_ok) {
            $not_ok_detail = strlen($newpassword)<5? $plugin_tx['memberpages']['error_too_short'] : $plugin_tx['memberpages']['error_forbidden_chars'];
        }

        $newemail_not_ok   = ($newemail && !preg_match('!^[^\r\n|,]+@[^\s|;|{|}|,]+$!',$newemail))? true : false;

        $fullname_not_ok   = ($newfullname && !preg_match('!^[^\r\n|;|{|}|<|>|,]*$!',$newfullname))? true : false;

        if($pw_found && !$pw_wrong && !$newpw_notmatching && !$newpw_not_ok && !$newemail_not_ok && !$fullname_not_ok ) {

            $newpassword = $newpassword? $newpassword : $oldpassword;

            $pattern = '!^'.$_SESSION['username'].','.preg_quote($oldpassword).',(.*),.*$!Um';
            $replacement = $_SESSION['username'].','.$newpassword.',${1},'.$newemail.','.$newfullname;

            $memberslist =  file_get_contents($pth['folder']['base'] . $plugin_cf['memberpages']['csvfile']);
            $newmemberslist =  preg_replace($pattern,$replacement,$memberslist);
            $nochange = ($newmemberslist == $memberslist)? true : false;
            if(file_put_contents($pth['folder']['base'] . $plugin_cf['memberpages']['csvfile'],$newmemberslist) && !$nochange)
            {
                $successfulchange = true;
                if($newpassword) $_SESSION['password'] = $newpassword;
                if($newfullname != $_SESSION['fullname']) $_SESSION['fullname'] = $newfullname;
            }
        }

        $o  .= "\n<div class='mpp_message'>\n";
        if (!$pw_found)         $o .= $plugin_tx['memberpages']['error_password_not_entered'].tag('br').tag('br');
        if ($pw_wrong)          $o .= $plugin_tx['memberpages']['error_wrong_password'].tag('br').tag('br');
        if ($newpw_notmatching) $o .= $plugin_tx['memberpages']['error_passwords_not_matching'].tag('br').tag('br');
        if ($newpw_not_ok)      $o .= $plugin_tx['memberpages']['notice_password_problem'].' ('.$not_ok_detail.')'.tag('br').tag('br');
        if ($newemail_not_ok)   $o .= $plugin_tx['memberpages']['error_email_wrong'].tag('br').tag('br');
        if ($fullname_not_ok)   $o .= $plugin_tx['memberpages']['error_fullname_wrong'].tag('br').tag('br');
        if ($nochange)          $o .= $plugin_tx['memberpages']['error_no_change_detected'].tag('br').tag('br');

        $o .= $successfulchange
            ? $plugin_tx['memberpages']['notice_data_successful_changed']
            : $plugin_tx['memberpages']['notice_data_not_changed'];
        $o .= "\n</div>\n";

        // writing to log file
        if($successfulchange)
        {
            $logfile = fopen($pth['folder']['plugins'].$plugin.'/logfile/logfile.txt', 'a');
            fwrite($logfile, date("Y-m-d H:i:s") . $_SESSION['username'] . ' changed his/her data' . "\n");
        }

    }

    // ============================== Members control panel entry form ==============================
    else
    {
        $o = '<div class="mpp_message" id="memberspanel">'
           . sprintf($plugin_tx['memberpages']['member_control_panel_greeting'],$_SESSION['username'])
           . '<form action="" method="post">'
           . tag('input type="hidden" name="function" value="memberspanel"')
           . tag('input type="hidden" name="memberspanel" value="1"')
           . '<table class="mpp_memberspanel"><tr><td>'
           . $plugin_tx['memberpages']['member_old_password']
           . ' </td><td>'
           . tag('input type="text" name="oldpassword" value=""')
           . "</td></tr>\n"
           . '<tr><td>'
           . $plugin_tx['memberpages']['member_new_password1']
           . ' </td><td>'
           . tag('input type="text" name="newpassword" value=""')
           . "</td></tr>\n"
           . '<tr><td>'
           . $plugin_tx['memberpages']['member_new_password2']
           . ' </td><td>'
           . tag('input type="text" name="newpassword2" value=""')
           . "</td></tr>\n"
           . '<tr><td>'
           . $plugin_tx['memberpages']['member_new_email']
           . tag('br');

        foreach ($user_array as $i=>$value)
        {
            if($_SESSION['username'] == $user_array[$i]) {
                $user_email = $email_array[$i];
                $user_fullname = $fullname_array[$i];
                break;
            }
        }

        $o .= '</td><td>'
           .  tag('input type="text" name="newemail" value="'.$user_email.'"')
           .  "</td></tr>\n";

        if($plugin_cf['memberpages']['show_fullname']) {
            $o .= '<tr><td>' . $plugin_tx['memberpages']['notice_your_fullname_is'] . '</td><td>'
               .  tag('input type="text" value="'.$user_fullname.'" name="newfullname"') . '</td><tr>'."\n";
        }

        $o .= '<tr><td>'
           .  tag('input type="button" value="'.$plugin_tx['memberpages']['close_without_saving'].'"
                onclick="document.getElementById(\'memberspanel\').style.display = \'none\';"')
           .  ' </td><td>'
           .  tag('input type="submit" name="submit" value="'.$plugin_tx['memberpages']['save_settings'].'"')
           .  "</td></tr>\n";

        $o .= "</table>\n"
           .  "\n"
           .  '</form>'
           .  "\n"
           .  '</div>';
    }
}

##################################################################################################

// FUNCTIONS

// session entries
function mp_session($s)
{
    global $_SESSION;
    if(isset($_SESSION[$s]))return $_SESSION[$s];else return'';
}


function memberslogin()
{
    global $sn,$su,$plugin_cf,$plugin_tx,$tx;
    $o = '';

    if(!isset($_SESSION['username']))
    {
        if($plugin_cf['memberpages']['small_login'])
        {
           $o .= "<a class='not_clicked' id='small_memberpageslogin'
             onclick=\"
             if (document.getElementById('small_memberpageslogin').className == 'not_clicked') {
               document.getElementById('small_memberpageslogin').className = 'clicked';
               document.getElementById('memberpageslogin').style.display = 'block';
             } else {
               document.getElementById('small_memberpageslogin').className = 'not_clicked';
               document.getElementById('memberpageslogin').style.display = 'none';
             }\">" . $plugin_tx['memberpages']['log_in_small'] .'</a>';
            $o .= '<div id="memberpageslogin">';
        }
        $o .= "\n"
           .  '<form action="'.$sn.'?'.$su.'" method="post">'
           .  "\n"
           .  tag('input type="submit" name="submit" style="display:none"')
           .  tag('input type="hidden" name="function" value="memberslogin"')
           .  "\n"
           .  $plugin_tx['memberpages']['memberslist_username']
           .  tag('br')
           .  "\n"
           .  tag('input type="text" name="username" class="mpp_member" tabindex="1"')
           .  tag('br')
           .  "\n"
           .  $plugin_tx['memberpages']['memberslist_password'];
        $o .= tag('br')
           .  "\n"
           .  tag('input type="password" name="password" class="mpp_member" tabindex="2"')
           .  tag('br')
           .  "\n"
           .  tag('input type="submit" name="submit" class="mpp_member_button" value="'.$plugin_tx['memberpages']['log_in'].'" tabindex="3"')
           .  "\n";

        if($plugin_cf['memberpages']['rememberme'])
        {
            $o.= '<span style="white-space:nowrap;">'. tag('input type="checkbox" name="remember" tabindex="4"')
              .  '<span class="mpp_small">'.$plugin_tx['memberpages']['log_in_remember_me']."</span></span>\n";
        }
        if($plugin_cf['memberpages']['passwordforgotten'] && $plugin_cf['memberpages']['site_email'])
        {
            $o .= tag('input type="submit" name="passwordforgotten" value="'
               .  $plugin_tx['memberpages']['passwordforgotten'].'" class="mpp_small_button" tabindex="5"');
        }
        $o.= '</form>'."\n"."\n";
        if($plugin_cf['memberpages']['small_login'])
        {
            $o.=  '</div><script type="text/javascript">
                // <![CDATA[
                    document.getElementById(\'memberpageslogin\').style.display = \'none\';
                 // ]]>
                </script>';
        }
    }
    else
    {
        $o = loggedinform();
    }
    return $o;
}

function loggedinform ()
{
    global $sn,$su,$plugin_cf,$plugin_tx,$tx,$pth;
    $o = tag('br')
       . "\n"
       . sprintf($plugin_tx['memberpages']['notice_loggedin'], $_SESSION['username'])
       . "\n"
       . tag('br');

    if($plugin_cf['memberpages']['show_actives']) $o .=  tag('br').$plugin_tx['memberpages']['notice_active_members'] . ': ' . memberlist(true);
    $o .=  tag('br');

    $o .='<form style="display:inline;" action="'.$sn.'?'.$su.'" method="post">'
       . "\n"
       . tag('input type="hidden" name="function" value="memberslogout"')
       . tag('input type="submit" value="'.$plugin_tx['memberpages']['log_out'].'"')."\n"
       . '</form>'
       . "\n";
    if($plugin_cf['memberpages']['usecsvfile'] && $plugin_cf['memberpages']['controlpanel']) {
        $o .= '<form style="display:inline;" action="'.$sn.'?'.$su.'" method="post">'
           .  tag('input type="hidden" name="function" value="memberspanel"')
           .  tag('input type="submit" class="mpp_small_button" value="'.$plugin_tx['memberpages']['member_control_panel'].'"')."\n"
           .  '</form>'
           .  "\n";
    }

    return $o;
}

function membersnotice()
{
    global $sn,$su,$plugin_cf,$plugin_tx,$tx;
    $plugin = basename(dirname(__FILE__),"/");
    if(!isset($_SESSION['username']))
    {
        $o = '';
    }
    else
    {
        $o = loggedinform();
    }
    return $o;
}


if($plugin_cf['memberpages']['texttrigger']) {

    function member($level=0)
    {
        global $sn,$plugin_tx,$plugin_cf;
        if(headers_sent($filename,$linenum))
        {
            echo "ERROR : memberpages detected that someone already had sent headers, look for the error in $filename line $linenum";
            exit;
        }
        if(!$level || !$plugin_cf['memberpages']['accessmode'])
        {
            if(!isset($_SESSION['username'],$_SESSION['accesslevel']))
            {
                header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_error']);
                exit;
            }
        }
        elseif($plugin_cf['memberpages']['accessmode']==1)
        {
            if(!isset($_SESSION['username'],$_SESSION['accesslevel'])
                || mp_session('accesslevel') != $level)
            {
                header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_error']);
                exit;
            }
        }
        elseif($plugin_cf['memberpages']['accessmode']==2)
        {
            if(!isset($_SESSION['username'],$_SESSION['accesslevel'])
                   ||  mp_session('accesslevel') < $level)
            {
                header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_error']);
                exit;
            }
        }
        elseif($plugin_cf['memberpages']['accessmode'] > 2)
        {
            if(!isset($_SESSION['username'],$_SESSION['accesslevel'])
                   ||  !(mp_session('accesslevel') & pow(2,$level-1)))
            {
                header('Location: '.CMSIMPLE_URL.'?'.$plugin_tx['memberpages']['page_error']);
                exit;
            }
        }
    }
}

?>
